!- TRIANGULAR μOS 1.10/VIC for Commodore VIC-20 5KB
!- SIMCITY


!- Set variables & run SIMCITY
1 print"{clear}{142}":poke36879,136:q$=chr$(34):bd=peek(900):s=peek(648)*256:cl=((peek(648)and3)+148)*256:dimv$(22):dimh$(22):fori=.to22:v$(i)=right$(sr$,i):h$(i)=right$(sd$,i):goto43

!- Cursor click handling
2v=v+1:ifv>19thenv=19
3return
4h=h-1:ifh<.thenh=.
5return
6h=h+1:ifh>21thenh=21
7return
8v=v-1:ifv<2thenv=2
9return

!- Store screen cell under cursor position
10c1=(v*22+h)+s:cv=peek(c1):return

!- Init game values & draw black space background for color memory
11 v=10:h=10:o=0:r0=.:c0=.:i0=.:f=1000:e=.:yr=2000:print"{clear}";:fori=.to21:print"{black}                      ";:nexti

!- SIMCITY loop
12e=e+1:print"{home}{yellow}year {left}{cyan}"int(yr)"{left} {yellow}pop: {left}{cyan}"o"{left} {return}{home}{down}{yellow}"f"{left}  ":pokes+22,36:ife>=10then:e9=e9+1:e=.:gosub31
13pokec1,cv:c1=(v*22+h)+s:cv=peek(c1):pokec1,158:sj=peek(37151):poke37154,127:tj=peek(37152):poke37154,255:if(128andtj)=.thengosub6
14if(16andsj)=.thengosub4
15if(8andsj)=.thengosub2
16if(4andsj)=.thengosub8
17getk$:ifk$=""then12
18ifk$=" "andcv=32andf>9thencv=186:f=f-10
19ifk$="{f1}"then43
20ifk$<>" "thengosub22
21goto12

!- Ckeck key for zone
22 ifk$="r"andf>=200thengosub26:ifep<1thencl$="{green}":gosub30:f=f-200
23 ifk$="c"andf>=800thengosub26:ifep<1thencl$="{blue}":gosub30:f=f-800
24 ifk$="i"andf>=3200thengosub26:ifep<1thencl$="{yellow}":gosub30:f=f-3200
25 return

!- If zone can be placed
26 ep=.:c9=((v-1)*22+(h-1))+s:forz0=.to2:forz1=.to2:ifpeek(c9+(z0*22)+z1)<>32thenep=ep+1
27 ifv<3orv>17orh<1orh>20thenep=ep+1
28 nextz1,z0:ifcv=32thenep=ep-1
29 return

!- Draw zone
30 print"{home}";:forl=2tov:print"{down}";:nextl:forl=1toh:print"{right}";:nextl:printcl$"{left}O{cm t}P{down}{left*3}{cm g}{reverse on}"k$"{reverse off}{cm m}{down}{left*3}L{cm @}{186}":cv=peek(c1):return

!- Check random city plots for zone plots
31 k=int(rnd(.)*374+44):dp=peek(s+k):ifdp=79ordp=99ordp=80ordp=101ordp=103ordp=76ordp=100ordp=122thengosub34
32 ife9>12thene9=.:yr=yr+1:f=f+o+c0+i0
33 return

!- Change zone plots
34 e0=.:e1=.:forz0=.to2:forz1=.to2:pc=peek((s+k-23)+(z0*22)+z1):ifpc=146thene0=1
35 ifpc=131thene0=2
36 ifpc=137thene0=3
37 ifpc=186thene1=1
38 nextz1,z0:ife1=.thenreturn

39 ife0=1theno=o+200:poke(s+k),dp+128
40 ife0=2thenc0=c0+400:poke(s+k),dp+128
41 ife0=3theni0=i0+800:poke(s+k),dp+128
42 return

!- Intro
43print"{clear}{right*6}{yellow}{reverse off}{cm d}{cm i*7}{cm f}{return}{right*6}{yellow}{reverse on}{cm k}simcity{reverse off}{cm k}{return}{right*6}{yellow}{reverse off}{cm c}{reverse on}{cm i*7}{reverse off}{cm v}{return}{down}{right*7}{green}O{cm t}P{reverse on}{black}:{reverse off}{blue}O{cm t}P{return}{right*2}{green}$200 {cm g}{reverse on}r{reverse off}{cm m}{reverse on}{black}:{reverse off}{blue}{cm g}{reverse on}c{reverse off}{cm m} $800{return}{right*7}{green}L{cm @}{186}{reverse on}{black}:{reverse off}{blue}{blue}L{cm @}{186}"
44print"{reverse on}{black}::::::::::::::::::::::{reverse off}{right*10}{reverse on}{black}:{reverse off}{blue}{yellow}O{cm t}P{return}{right*6}{black}$10 {reverse on}:{reverse off}{blue}{yellow}{cm g}{reverse on}i{reverse off}{cm m} $3200{return}{right*10}{reverse on}{black}:{reverse off}{blue}{yellow}L{cm @}{186}{return}{down*2}{cyan}(c)2022 {purple}{cm asterisk}{sh pound} {cyan}triangular{return}{down*2}{white} move: joy{return} palce: space,r,c,i{return}{down} {reverse on}{green}f1{reverse off}{white} start/menu{return}{down} {reverse on}{yellow}f8{reverse off}{white} exit"
45getk$:ifk$="{f8}"thenn$="games":goto49
46ifk$="{f6}"thenn$="gui":poke991,1:goto49
47ifk$="{f1}"then11
48goto45

!- Load
49poke36879,8:print"{clear}{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$n$q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new
