!- TRIANGULAR μOS 1.10/VIC for Commodore VIC-20 5KB
!- BIOS


!- Set variables
1print"{clear}{142}":poke36879,8:q$=chr$(34):v$="1.10/vic":bd=peek(900):wd=bd:dd=peek(909):fm=peek(998)

!- Launch screen
2print"{clear}";:gosub36:print"{purple}{cm @*22}";:gosub34:print"    {cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub35:print"      {cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub35:print"        {cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub35:print"          {cm asterisk}{sh pound}":gosub35
3print"{blue}{down*2} {cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}{return}  {cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f}{return}  {cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5}{return}{cyan}{down}(c)2022  {cm m}{cm x}os "v$:n$="gui":ifrn=.thengosub56
4gosub36:printtab(9)"{down*2}{reverse on}{yellow}f1{reverse off} {green}bios setup":poke198,.:gosub37
5getk$:ifk$="{f1}"then7

!- Load GUI
6print"{clear}{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$n$q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- BIOS Setup menu
7print"{clear}{purple}{cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan} triangular bios{return} {purple}{cm asterisk}{sh pound}{cyan}  (c)2022{down*2}{return} {blue}c{red}= {cyan}vic-20"fm"{left}kb ram{down}{return} #: device: boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
8db=dd:wb=wd:bb=bd:print" {reverse on}{red}1{cyan}{reverse off}: ":gosub64:fori=.to3
9gosub44:print8+i;"{left}:",:ifdi(i)=.thenprint"{left*7}none"
10ifdi(i)=1thenprint"{left*7}cbm "dt$(i)"{return}","{up}{right*2}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
11nexti:print"{down} boot:     work:{return}{down*2} {reverse on}{red}t{cyan}{reverse off}ime:{return}{down} {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2} {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke198,.
12gosub38:gosub43:getk$:ifk$=""then12
13ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto2
14ifk$="r"thenti$="000000"
15ifk$="1"thengosub67:gosub64
16ifk$="{f1}"theni=.:gosub39
17ifk$="{f2}"theni=.:gosub41
18ifk$="{f3}"theni=1:gosub39
19ifk$="{f4}"theni=1:gosub41
20ifk$="{f5}"theni=2:gosub39
21ifk$="{f6}"theni=2:gosub41
22ifk$="{f7}"theni=3:gosub39
23ifk$="{f8}"theni=3:gosub41
24ifk$="t"thengosub28
25ifk$="s"thengosub62:n$="uos":goto6
26ifk$="b"thensys64802
27goto12

!- Time change
28ks$="":kv$="":poke198,.:fori=.to5
29gosub38:gosub43:print"{down}{right*7}{blue}"kv$"{cyan}":getk$:ifk$=""then29
30as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto32
31goto29

!- Load GUI
32kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
33nexti:gosub43:print"{down}{right*7}       ":ti$=ks$:poke198,.:return

!- Draw horizontal line 1
34print"{sh asterisk*22}";:return

!- Draw horizontal line 2
35print"{cm t*22}";:return

!- Delay 500 for's
36forj=.to500:nextj:return

!- Delay 2000 for's
37fori=.to2000:nexti:return

!- Time update > setup
38t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*16}{right*7}"t1$":"t2$":"t3$:return

!- Set Boot drive
39ifpeek(901+i)=1thenbd=8+i:return
40return

!- Set Work drive
41ifpeek(901+i)=1thenwd=8+i:return
42return

!- Boot & Work disk drive update > setup
43print"{home}{down*13}{right*6}{yellow}"bd"{left} ","{right*5}{green}"wd"{left} {cyan}":return

!- Disk drive database
44di(i)=peek(901+i):dn(i)=peek(905+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
45ifdn(i)=16thendt$(i)="2040"
46ifdn(i)=76thendt$(i)="1541"
47ifdn(i)=170thendt$(i)="1540"
48ifdn(i)=173thendt$(i)="1571"
49ifdn(i)=108thendt$(i)="1581"
50ifdn(i)=7thendt$(i)="2031"
51ifdn(i)=32thendt$(i)="3040"
52ifdn(i)=169thendt$(i)="4040"
53ifdn(i)=255thendt$(i)="1551"
54ifdn(i)=48thendt$(i)="{left*4}sd2iec"
55return

!- Load uos>cfg
56rn=1:open8,bd,8,"uos>cfg,s,r":close8:gosub63:poke991,1:ifer<>.then61
57open8,bd,8,"uos>cfg,s,r":input#8,v1$:ifv$<>v1$then60
58input#8,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub63:poke997,val(gr$):poke996,val(gc$):poke994,val(cg$):wd=val(wd$):dd=val(dd$):poke909,dd:ifpeek(893+wd)=.thenwd=bd
59poke910,wd:poke990,val(tc$):poke911,val(pp$):return

60close8:gosub63
61print"{clear}{red}system disk{return}not present!":fork=.to3:poke36878,15:poke36876,218:forj=1to120:nextj:poke36876,.:forj=1to100:nextj:nextk:forj=.to250:nextj:poke36879,27:print"{blue}{down*2}**** cbm basic v2 ****{down}{left}"((int((5200+fre(x))/1024)-1.5)*1024)-1"bytes free"chr$(9):poke808,112:new

!- Save uos>cfg
62open1,bd,15,"s0:uos>cfg":close1:open8,bd,8,"uos>cfg,w,s":print#8,v$:print#8,wd:print#8,dd:print#8,peek(996):print#8,peek(997):print#8,peek(994)::print#8,peek(990):print#8,peek(911):close8:poke909,dd:poke900,bd:poke910,wd:gosub63:return

!- Read disk error chanell
63open1,bd,15:input#1,er,er$,tr,sc:close1:return

!- Update Datasette status graphic > setup
64ifdd=.thenprint"{home}{down*7}{right*4}none         ":return
65ifdd=1thenprint"{home}{down*7}{right*4}cbm datasette":return
66return

!- Datasette enable On/Off
67ifdd=.thendd=1:return
68ifdd=1thendd=.:return
69return
