!- TRIANGULAR μOS 1.10/VIC for Commodore VIC-20 5KB
!- MONITOR


!- Set variables
1 print"{clear}{142}":poke36879,104:q$=chr$(34):dimrn(3):dimhe(3):dimhe$(3):dimdc(3):as$="start address":bd=peek(900)

!- Command loop
2 gosub12
3 in$="":ip$="*":gosub45:ifin$="exit"then17
4 ifin$="clr"then2
5 ifin$="entry"then18
6 ifin$="copy"then33
7 ifin$="fill"then58
8 ifin$="show"then68
9 ifin$="help"thengosub85
10 ifin$="go"then13
11 print"{down} {yellow}invalid command!{white}":goto3

!- Main title
12 print"{clear}{purple}{cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan}triangular monitor{purple} {cm asterisk}{sh pound}{cyan} (c)2022{white}":return

!- Go
13 ip$=as$:gosub46:ifr=2then3
14 hl=4:gosub27:ifr=1then13
15 ah=int(dc/256):al=dc-(ah*256):poke897,76:poke898,al:poke899,ah:sys897
16 goto3

!- Load apps (exit)
17 print"{clear}":poke36879,8:print"{down*12}"tab(8)"{purple}{cm asterisk}{reverse on}    {reverse off}{sh pound}{down}{left*5}{cm asterisk}{reverse on}  {reverse off}{sh pound}{down}{left*3}{cm asterisk}{sh pound}{return}{down*2}{white}     {cm @*12}{return}{white}    {cm m}{reverse on}{blue}{cm m*7}{reverse off}     {white}{cm g}{return}{white}     {cm t*12}{return}{white}{down}      loading...{home}{black}load "q$"apps"q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Entry
18 ip$=as$:gosub46:ifr=2then3
19 hl=4:gosub27:ifr=1then18
20 ad=dc:hl=2
21 ot=ad:gosub52
22 ip$="address "+hw$:gosub46:ifin$="r"then25
23 ifr=2then3
24 gosub27:ifr=1then22
25 pokead,dc
26 ad=ad+1:goto21

!- Max digit test
27 r=.:dc=.:nl=len(in$):ifnl>hlthenprint"{down}{yellow} max"hl"digits!{white}":r=1:return
28 r=.:fori=1tonl:td$=mid$(in$,i,1):tn=asc(td$):iftn>47andtn<58thentd=tn-48:goto31
29 iftn>64andtn<71thentd=tn-55:goto31
30 r=1
31 dc=dc+(td*(16^(nl-i))):nexti:ifr=1thenprint"{down} {yellow}invalid hex number!{white}":return
32 return

!- Copy
33 ip$="copy from 1st address{return}":gosub46:ifr=2then3
34 hl=4:gosub27:ifr=1then33
35 a1=dc
36 ip$="copy from 2st address{return}":gosub46:ifr=2then3
37 gosub27:ifr=1then36
38 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto36
39 a2=dc
40 ip$="copy to address":gosub46:ifr=2then3
41 gosub27:ifr=1then40
42 ad=dc
43 j=.:fori=a1toa2:mv=peek(i):if(ad+j)>65535thenj=j-1
44 pokead+j,mv:j=j+1:nexti:goto3

!- Command entry
45 print"{down}"ip$":";:open1,.:input#1,in$:close1:print"{white}{reverse off}":return

!- Entry adress
46 r=.:gosub45:gosub50:ifr=1orr=2thenreturn
47 return

!- Stop on X
48 r=.:gosub50:ifr=1orr=2thenreturn
49 return

!- Check for X-stop
50 ifin$="x"thenr=2:return
51 return

!- Convert hex to dec
52 he(.)=int(ot/4096):he(1)=int((ot-(he(.)*4096))/256)
53 he(2)=int((ot-(he(.)*4096)-(he(1)*256))/16)
54 he(3)=ot-(he(.)*4096)-(he(1)*256)-(he(2)*16)
55 forg=.to3:ifhe(g)<10thenhe$(g)=chr$(48+he(g))
56 ifhe(g)>9thenhe$(g)=chr$(55+he(g))
57 nextg:hw$=he$(.)+he$(1)+he$(2)+he$(3):return

!- Fill
58 ip$="fill 1st address":gosub46:ifr=2then3
59 hl=4:gosub27:ifr=1then61
60 a1=dc
61 ip$="fill 2nd address":gosub46:ifr=2then3
62 gosub27:ifr=1then61
63 ifdc<a1thenprint"{down} 2nd address lower than 1st!":goto61
64 a2=dc
65 ip$="fill memory value":gosub46:gosub48:ifr=2then3
66 hl=2:gosub27:ifr=1then65
67 mv=dc:fori=a1toa2:pokei,mv:nexti:goto3

!- Show
68 ip$=as$:gosub46:ifr=2then3
69 hl=4:gosub27:ifr=1then68
70 ad=dc
71 ifad<.thenad=.
72 ifad>65520thenad=65520
73 gosub12:fori=.to15step2:ot=ad+i:gosub52:print"{down} "hw$":";:ot=peek(ad+i)
74 gosub52:printright$(hw$,2);,;:ot=ad+i+1:gosub52:print" "hw$":";
75 ot=peek(ad+i+1):gosub52:printright$(hw$,2):nexti
76 print"{down*2} {green}{reverse on}f1{cyan}{reverse off} <  {green}{reverse on}f2{cyan}{reverse off} >  {yellow}{reverse on}f8{cyan}{reverse off} stop{white}"
77 geta$:ifa$="{f2}"thenad=ad+16:goto71
78 ifa$="{f1}"thenad=ad-16:goto71
79 ifa$="{f8}"then3
80 goto77

!- F1 to continue & F8 to stop
81 print"{down*2} {green}{reverse on}f1{reverse off}{cyan} to continue{down}{return} {yellow}{reverse on}f8{reverse off}{cyan} to stop";
82 getk$:ifk$="{f1}"thenreturn
83 ifk$="{f8}"thent=1:return
84 goto82

!- Help
85 gosub12:print"{down*2} monitor help:{return}{down*2} help - show help{return}{down} exit - quit to{return}"tab(8)"desktop{return}{down} entry - entry values{return}","{left*2}to memory{return}{down} show - show memory{return}","{left*3}content":t=.:gosub81:ift=1then2
86 gosub12:print"{down*2} monitor help:{return}{down*2} fill - fill memory{return}","{left*3}block{return}{down*2} copy - copy memory{return}","{left*3}block{return}{down} go - run assembler{return}"tab(6)"program":t=.:gosub81:ift=1then2
87 gosub12:print"{down*2} monitor help:{return}{down} clr - clears screen{return}{down*2} x - cancel entering{return}{right*5}numbers{return}{down} r - in entry mode{return}     repeat previous{return}     value":gosub81:goto2
